import'./../../external/@lit/reactive-element/reactive-element.js';import'./../../external/lit-html/lit-html.js';import'./../../external/lit-element/lit-element.js';import{css as e}from'./../../external/@lit/reactive-element/css-tag.js';var o=e`*,
*::before,
*::after {
  box-sizing: border-box;
}

:root {
  --kd-current-breakpoint: sm;
}
@media (min-width: 42rem) {
  :root {
    --kd-current-breakpoint: md;
  }
}
@media (min-width: 74rem) {
  :root {
    --kd-current-breakpoint: lg;
  }
}
@media (min-width: 82rem) {
  :root {
    --kd-current-breakpoint: xl;
  }
}
@media (min-width: 99rem) {
  :root {
    --kd-current-breakpoint: max;
  }
}

:host {
  display: inline-block;
  width: 264px;
}

.card-wrapper {
  position: relative;
  padding: 16px;
  background-color: var(--kd-color-background-ui-default);
  outline: 1px solid var(--kd-color-border-light);
  border-radius: 8px;
  height: 100%;
}
.card-wrapper-clickable {
  position: relative;
  display: inline-block;
  color: unset;
  width: inherit;
  text-decoration: none;
  background-color: var(--kd-color-background-ui-default);
  border-radius: 8px;
  padding: 16px;
  outline: 1px solid transparent;
  transition: outline-color 150ms ease-out, box-shadow 150ms ease-out;
}
.card-wrapper-clickable:hover {
  outline-color: var(--kd-color-border-ui-hover);
  box-shadow: var(--kd-elevation-level-2);
}
.card-border {
  outline: 1px solid var(--kd-color-border-light);
  box-shadow: var(--kd-elevation-level-1);
}`;export{o as default};
//# sourceMappingURL=card.scss.js.map
